【优先算法】双指针 --(结合例题讲解解题思路)(C++)

目录

​编辑

[1. 题目:三数之和](#1. 题目:三数之和)

1.1算法思路

1.2代码实现

2.题目:四数之和

2.1算法思路

2.2代码实现


1. 题目:三数之和

力扣-三数之和https://leetcode.cn/problems/3sum/

1.1算法思路

方法一:暴力解法

三层for循环,一个一个去找。因为有重复的,所以我们要将数据放进set,去重。

总结,这种方法,时间复杂度太高,如果用这个方法,难度根本没有,所以面试官想要的根本不是这种!!!

方法二:双指针

第一步,排好序

第二步,固定一个数 a,因为题干说,三个数和==0,那么,我只需要在固定的这个数,的后面的区间利用"双指针"找到两个数,和== -a 即可。

当然,在过程中,我们需要特别注意的是,做到不重,不漏。

第三步,不漏

就是在left,right在移动过程中,找到了符合条件的之后,还要继续在区间查找。

第四步,不重

做到去重,就是每次找到符合条件的数,left++,right--,但是如果变化之后的数还是与之前的一样numsleft==numsleft-1 或者 numsright==numsright+1 此时,我们需要继续++或--

!!!但是注意,不要越界需要有限制条件left < right。

1.2代码实现

暴力解法的代码实现,我这就不写了。双指针的解法思路也是有两种,例如下 方法一和方法二

2.题目:四数之和

力扣-四数之和https://leetcode.cn/problems/4sum/description/

2.1算法思路

四数之和算法思路和三数之和是一样的,唯一的差别就是,四数定了两个固定数(并不是完全固定的数哈!!!咱们脑子要灵活一点)

第一步,定第一个数 a=numsi

第二步,定第二个数 b=numsx

第三步,定left,right。(注意,{ a,b,numsleft,numsright }就是我们符合要求的数)

其余步骤也就和三数之和一样,做到,不重,不漏。唯一差别就是这里多了一步,b的去重。

2.2代码实现

本期学习到此结束,感谢大家支持!!!

相关推荐
冻柠檬飞冰走茶10 分钟前
字母移动游戏题解:贪心求最长可保留连续子串(附 C 实现)
c语言·开发语言·数据结构·算法·动态规划
FRing0325 分钟前
vue2干货总结7(自定义指令、插槽、单页应用程序、路由的使用(VueRouter))
开发语言·前端·vue.js·vue2
雪落漂泊29 分钟前
C++算法 二分查找篇(上)
开发语言·c++·算法
波力海苔夹心脆6752 小时前
C# WPF 资源字典详解:ResourceDictionary、MergedDictionaries 与自定义控件案例
开发语言·c#·wpf·入门教程·resource·资源字典
不会算法的笨小孩2 小时前
异常的使用以及会出现的问题
开发语言·c++·c++11·异常
LabVIEW开发2 小时前
LabVIEW 连接板:28 个端子怎么排,优先级怎么定
java·算法·labview
严肃小白兔4 小时前
MATLAB 数值计算中的精度与误差问题:浮点运算、误差传播与数值稳定性
人工智能·算法·matlab
Hhy_11074 小时前
《C++深度解构06》手撕 string —— 从底层内存管理到深浅拷贝彻底吃透
c语言·开发语言·c++·学习·visual studio
starzy19904 小时前
深入理解Scala函数定义:从方法到函数的类型跨越
开发语言·scala
starzy19904 小时前
深入理解Scala递归函数:从栈溢出到尾调用优化
开发语言·scala